Xfce Foundation Classes
Main Page | Index | Namespace List | Alphabetical List | Class List | File List

# Xfc::Gtk::EventBox Class Reference

A GtkEventBox C++ wrapper class. More...

`#include <xfc/gtk/eventbox.hh>`

Inheritance diagram for Xfc::Gtk::EventBox:

List of all members.

## Public Member Functions

Constructors

- EventBox ()
    Construct a new EventBox.
- virtual ~EventBox ()
    Destructor.

Accessors

- GtkEventBox * gtk_event_box () const
    Get a pointer to the GtkEventBox structure.
- operator GtkEventBox * () const
    Conversion operator; safely converts an EventBox to a GtkEventBox pointer.
- bool get_visible_window () const
    Determines whether the event box has a visible window (see set_visible_window() for details).
- bool get_above_child () const
    Determines whether the event box window is above or below the windows of its child (see set_above_child() for details).

Methods

- void set_visible_window (bool visible_window)
    Set whether the event box uses a visible or invisible child window.
- void set_above_child (bool above_child)
    Set whether the event box window is positioned above the windows of its child, as opposed to below it.

## Protected Member Functions

Constructors

- EventBox (GtkEventBox *event_box, bool owns_reference=false)
    Construct a new EventBox from an existing GtkEventBox.

## Detailed Description

A GtkEventBox C++ wrapper class.

The EventBox widget is a subclass of Bin which also has its own window. It is useful since it allows you to catch events for widgets which do not have their own window.

See also: the EventBox HOWTO and example.

## Constructor & Destructor Documentation

Xfc::Gtk::EventBox::EventBox | ( | GtkEventBox * | event_box,
|  | bool | owns_reference = `false`
| ) | `[explicit, protected]`

Construct a new EventBox from an existing GtkEventBox.

Parameters:

  | event_box | A pointer to a GtkEventBox.
  | owns_reference | Set false if the initial reference count is floating, set true if it's not.

The event_box can be a newly created GtkEventBox or an existing GtkEventBox (see G::Object::Object).

## Member Function Documentation

bool Xfc::Gtk::EventBox::get_above_child | ( |  | ) | const

Determines whether the event box window is above or below the windows of its child (see set_above_child() for details).

Returns:
  true if the event box window is above the window of its child.

bool Xfc::Gtk::EventBox::get_visible_window | ( |  | ) | const

Determines whether the event box has a visible window (see set_visible_window() for details).

Returns:
  true if the event box window is visible.

void Xfc::Gtk::EventBox::set_above_child | ( | bool | above_child | ) |

Set whether the event box window is positioned above the windows of its child, as opposed to below it.

Parameters:

  | above_child | Set true if the event box window is above the windows of its child.

If the window is above, all events inside the event box will go to the event box. If the window is below, events in windows of child widgets will first go to that widget, and then to its parents. The default is to keep the window below the child.

void Xfc::Gtk::EventBox::set_visible_window | ( | bool | visible_window | ) |

Set whether the event box uses a visible or invisible child window.

Parameters:

  | visible_window | Set true if the event box uses a visible child window.

The default is to use visible windows. In an invisible window event box, the window that the event box creates is a Gdk::INPUT_ONLY window, which means that it is invisible and only serves to receive events.

A visible window event box creates a visible (Gdk::INPUT_OUTPUT) window that acts as the parent window for all the widgets contained in the event box. You should generally make your event box invisible if you just want to trap events. Creating a visible window may cause artifacts that are visible to the user, especially if the user is using a theme with gradients or pixmaps. The main reason to create a non input-only event box is if you want to set the background to a different color or draw on it.

Note: There is one unexpected issue for an invisible event box that has its window below the child (see set_above_child()). Since the input-only window is not an ancestor window of any windows that descendent widgets of the event box create, events on these windows aren't propagated up by the windowing system, but only by GTK+. The practical effect of this is if an event isn't in the event mask for the descendant window (see Gtk::Widget::add_events()), it won't be received by the event box. This problem doesn't occur for visible event boxes, because in that case, the event box window is actually the ancestor of the descendant windows, not just at the same place on the screen.

The documentation for this class was generated from the following file:

- eventbox.hh

Xfce Foundation Classes

Copyright © 2004-2005 The XFC Development Team | XFC 4.3